void
print_dashes (MYSQL_RES *res_set)
{
MYSQL_FIELD   *field;
unsigned int  i, j;

  mysql_field_seek (res_set, 0);
  fputc ('+', stdout);
  for (i = 0; i < mysql_num_fields (res_set); i++)
  {
    field = mysql_fetch_field (res_set);
    for (j = 0; j < field->max_length + 2; j++)
      fputc ('-', stdout);
    fputc ('+', stdout);
  }
  fputc ('\n', stdout);
}

void
process_result_set (MYSQL *conn, MYSQL_RES *res_set)
{
MYSQL_ROW     row;
/* #@ _COL_WID_CALC_VARS_ */
MYSQL_FIELD   *field;
unsigned long col_len;
unsigned int  i;
/* #@ _COL_WID_CALC_VARS_ */

/* #@ _COL_WID_CALCULATIONS_ */
  /* Określenie szerokości wyświetlanych kolumn; zbiór wynikowy musi być */
  /* wygenerowany za pomocą funkcji mysql_store_result(), a nie mysql_use_result(). */
  mysql_field_seek (res_set, 0);
  for (i = 0; i < mysql_num_fields (res_set); i++)
  {
    field = mysql_fetch_field (res_set);
    col_len = strlen (field->name);
    if (col_len < field->max_length)
      col_len = field->max_length;
    if (col_len < 4 && !IS_NOT_NULL (field->flags))
      col_len = 4;  /* 4 = długość słowa "NULL". */
    field->max_length = col_len;  /* Wyzerowanie informacji o kolumnie. */
  }
/* #@ _COL_WID_CALCULATIONS_ */

  print_dashes (res_set);
  fputc ('|', stdout);
  mysql_field_seek (res_set, 0);
  for (i = 0; i < mysql_num_fields (res_set); i++)
  {
    field = mysql_fetch_field (res_set);
/* #@ _PRINT_TITLE_ */
    printf (" %-*s |", (int) field->max_length, field->name);
/* #@ _PRINT_TITLE_ */
  }
  fputc ('\n', stdout);
  print_dashes (res_set);

  while ((row = mysql_fetch_row (res_set)) != NULL)
  {
    mysql_field_seek (res_set, 0);
    fputc ('|', stdout);
    for (i = 0; i < mysql_num_fields (res_set); i++)
    {
      field = mysql_fetch_field (res_set);
/* #@ _PRINT_ROW_VAL_ */
      if (row[i] == NULL)       /* print the word "NULL" */
        printf (" %-*s |", (int) field->max_length, "NULL");
      else if (IS_NUM (field->type))  /* print value right-justified */
        printf (" %*s |", (int) field->max_length, row[i]);
      else              /* print value left-justified */
        printf (" %-*s |", (int) field->max_length, row[i]);
/* #@ _PRINT_ROW_VAL_ */
    }
    fputc ('\n', stdout);
  }
  print_dashes (res_set);
  printf ("Liczba zwróconych rekordów: %lu\n",
          (unsigned long) mysql_num_rows (res_set));
}
